#!/usr/bin/perl
#
# SmoothWall CGIs
#
# This code is distributed under the terms of the GPL
#
# (c) The SmoothWall Team
#
### 2006-1214 - wireless.cgi v.0.2test1 (alpha) for NoWireAP v.0.2 mod by catastrophe
# - Intended for use on Smoothwall Express 2.0 fixes9 ui-3.6.1 with SuperKernel 2.4.33-3-sk-v1 mod by BoHiCa
# - Support for the BLUE Interface mod by Daniel Hokka Zakrisson (daniel_hozac)
# - Support for Atheros-based wireless cards utilizing MadWifi drivers
# - Added "page generated in 'x' seconds" (thanks daniel_hozac)
# - Special thanks to Noven and Keith130 for without whom this mod couldn't get put together.
### 2006-1216 - wireless.cgi v.0.2test2 (alpha) for NoWireAP v.0.2 mod by catastrophe
# - Added additional settings
# - Implemented rc.wireless.update and nowireaphelper for on-the-fly gui updates
# - nowireaphelper "date and logging" borrowed from the Red Up Down Control (redud) v1.01 by electroman00
### 2006-1218 - wireless.cgi v.0.2test3 (alpha) for NoWireAP v.0.2 mod by catastrophe
# - Fixed WEP key off not turning off from gui
# - Bunch of tweaks
### 2007-0102- wireless.cgi v.0.2test4 (alpha) for NoWireAP v.0.2 mod by catastrophe
# - Added initial support for sw-wireless-blue mod (madwifi+hostapd) mod by Noven
# - Broke some stuff (i.e. On the fly changes don't work, must reboot for changes to take)
##
# Future plans:
# - Not sure. Let us know!
#
# - Disclaimer:
#    - Use at your own risk without any or implied warranty.
###

############
###HEADER###
############

require '/var/smoothwall/header.pl';

use Time::HiRes qw( gettimeofday );

###############
###VARIABLES###
###############

my (%nowireapsettings,%checked);


##########
###MENU###
##########

#&showhttpheaders();

$nowireapsettings{'ACTION'} = '';
#$nowireapsettings{'NOWIREAP_MODPROBE_DRIVER'} = 'ath_pci';	### debugging
#$nowireapsettings{'NOWIREAP_MODPROBE_AUTOCREATE'} = 'autocreate=ap';
#$nowireapsettings{'NOWIREAP_IP'} = '192.168.3.115';		### debugging
$nowireapsettings{'NOWIREAP_ACTIVATE_AP'} = 'off';		# access point "off" by default
### reference - http://madwifi.org/users-guide/node14.html
### 	wlanconfig VirtualAP create wlandev BaseDevice wlanmode mode [bssid||-bssid] [nosbeacon] 
$nowireapsettings{'NOWIREAP_WLANCONFIG_CREATE'} = 'wlandev wifi0 wlanmode ap';
$nowireapsettings{'NOWIREAP_IWCONFIG_MODE'} = 'master';
$nowireapsettings{'NOWIREAP_IWCONFIG_ESSID'} = 'smoothieAP';	# ESSID or Network Name
$nowireapsettings{'NOWIREAP_IWCONFIG_CHANNEL'} = '6';	# RF Frequency or Channel
$nowireapsettings{'NOWIREAP_IWCONFIG_RATE'} = 'auto';	# Data Transmit Rate
$nowireapsettings{'NOWIREAP_IWCONFIG_RTS'} = '2347';	# RTS/CTS Threshold 		# 2347
$nowireapsettings{'NOWIREAP_IWCONFIG_FRAG'} = '2346';	# Fragmentation Threshold	# 2346
$nowireapsettings{'NOWIREAP_IWCONFIG_TXPOWER'} = '15';	# Transmit Power
#$nowireapsettings{'NOWIREAP_IWCONFIG_RETRY'} = '';	# Retry Limit (NOT implemented in driver)
#$nowireapsettings{'NOWIREAP_IWCONFIG_SENS'} = '';	# Sensitivity Threshold (NOT implemented in driver)
$nowireapsettings{'NOWIREAP_SECURITY_MODE'} = 'none';	# access point "unsecure" by default
$nowireapsettings{'NOWIREAP_IWCONFIG_WEP_KEY'} = '';
$nowireapsettings{'NOWIREAP_WEP_KEY_TO_USE'} = '1';
$nowireapsettings{'NOWIREAP_WEP_KEY1'} = '7781B23A16586D2D4CC7807F01';	# starter wep key
$nowireapsettings{'NOWIREAP_WEP_KEY2'} = '';
$nowireapsettings{'NOWIREAP_WEP_KEY3'} = '';
$nowireapsettings{'NOWIREAP_WEP_KEY4'} = '';
$nowireapsettings{'NOWIREAP_WPA_KEY'} = 'smoothiemods';			# starter wpa key
$nowireapsettings{'NOWIREAP_WPA_ALGORITHM'} = 'TKIP';
$nowireapsettings{'NOWIREAP_IWPRIV_HIDE_SSID'} = '0';	# Enable/Disable Hiding of the 802.11 SSID
$nowireapsettings{'NOWIREAP_IWPRIV_MODE'} = 'auto';	# Wireless Mode
$nowireapsettings{'NOWIREAP_IWPRIV_TURBO'} = '0';
$nowireapsettings{'NOWIREAP_IWPRIV_BINTVAL'} = '100';	# Beacon Interval Value	# 100
$nowireapsettings{'NOWIREAP_HIDE_ALERTBOX'} = 'on';	# ...gain more gui space...
$nowireapsettings{'NOWIREAP_REFRESH'} = '0';		# 0=off, >0=on (in seconds)
$nowireapsettings{'NOWIREAP_SHOW_IFCONFIG'} = 'off';	### debugging
$nowireapsettings{'NOWIREAP_SHOW_IWCONFIG'} = 'off';	### debugging
$nowireapsettings{'NOWIREAP_SHOW_IWPRIV'} = 'off';	### debugging
$nowireapsettings{'NOWIREAP_SHOW_PREFERENCES'} = 'off';	### debugging
$nowireapsettings{'NOWIREAP_SHOW_HOSTAPD_PREFERENCES'} = 'off'; ### debugging
$nowireapsettings{'NOWIREAP_SHOW_HOSTAPD_CONF'} = 'off';	### debugging
################################
# http://madwifi.org/wiki/UserDocs/HostAP
# http://madwifi.org/wiki/StuckBeacon
$nowireapsettings2{'interface'} = 'ath0';					# hostapd
$nowireapsettings2{'driver'} = 'madwifi';					# hostapd
$nowireapsettings2{'logger_syslog'} = '-1';				# hostapd
$nowireapsettings2{'logger_syslog_level'} = '2';			# hostapd
$nowireapsettings2{'logger_stdout'} = '-1';				# hostapd
$nowireapsettings2{'logger_stdout_level'} = '2';			# hostapd
$nowireapsettings2{'debug'} = '0';						# hostapd
$nowireapsettings2{'dump_file'} = '/tmp/hostapd.dump';			# hostapd
$nowireapsettings2{'ctrl_interface'} = '/var/run/hostapd';		# hostapd
$nowireapsettings2{'ctrl_interface_group'} = '0';			# hostapd
$nowireapsettings2{'ssid'} = 'smoothieAP2';				### hostapd
$nowireapsettings2{'country_code'} = 'US';				# hostapd
$nowireapsettings2{'hw_mode'} = 'g';					# hostapd
$nowireapsettings2{'channel'} = '3';					### hostapd
$nowireapsettings2{'beacon_int'} = '100';					### hostapd (at least 15)
$nowireapsettings2{'dtim_period'} = '2';					# hostapd
$nowireapsettings2{'max_num_sta'} = '255';				# hostapd
$nowireapsettings2{'rts_threshold'} = '2347';				### hostapd
$nowireapsettings2{'fragm_threshold'} = '2346';				### hostapd
$nowireapsettings2{'macaddr_acl'} = '0';					# hostapd
$nowireapsettings2{'deny_mac_file'} = '/etc/hostapd/hostapd.deny';	# hostapd
$nowireapsettings2{'auth_algs'} = '1';					# hostapd
$nowireapsettings2{'ignore_broadcast_ssid'} = '0';			### hostapd
$nowireapsettings2{'wme_enabled'} = '1';					# hostapd
$nowireapsettings2{'wme_ac_bk_cwmin'} = '4';				# hostapd
$nowireapsettings2{'wme_ac_bk_cwmax'} = '10';				# hostapd
$nowireapsettings2{'wme_ac_bk_aifs'} = '7';				# hostapd
$nowireapsettings2{'wme_ac_bk_txop_limit'} = '0';			# hostapd
$nowireapsettings2{'wme_ac_bk_acm'} = '0';				# hostapd
$nowireapsettings2{'wme_ac_be_aifs'} = '3';				# hostapd
$nowireapsettings2{'wme_ac_be_cwmin'} = '4';				# hostapd
$nowireapsettings2{'wme_ac_be_cwmax'} = '10';				# hostapd
$nowireapsettings2{'wme_ac_be_txop_limit'} = '0';			# hostapd
$nowireapsettings2{'wme_ac_be_acm'} = '0';				# hostapd
$nowireapsettings2{'wme_ac_vi_aifs'} = '2';				# hostapd
$nowireapsettings2{'wme_ac_vi_cwmin'} = '3';				# hostapd
$nowireapsettings2{'wme_ac_vi_cwmax'} = '4';				# hostapd
$nowireapsettings2{'wme_ac_vi_txop_limit'} = '94';			# hostapd
$nowireapsettings2{'wme_ac_vi_acm'} = '0';				# hostapd
$nowireapsettings2{'wme_ac_vo_aifs'} = '2';				# hostapd
$nowireapsettings2{'wme_ac_vo_cwmin'} = '2';				# hostapd
$nowireapsettings2{'wme_ac_vo_cwmax'} = '3';				# hostapd
$nowireapsettings2{'wme_ac_vo_txop_limit'} = '47';			# hostapd
$nowireapsettings2{'wme_ac_vo_acm'} = '0';				# hostapd
$nowireapsettings2{'ieee8021x'} = '0';					# hostapd
$nowireapsettings2{'eapol_version'} = '1';				# hostapd
$nowireapsettings2{'eapol_key_index_workaround'} = '0';		# hostapd
$nowireapsettings2{'eap_server'} = '0';					# hostapd
$nowireapsettings2{'own_ip_addr'} = '127.0.0.1';			# hostapd
$nowireapsettings2{'wpa'} = '0';						### hostapd
$nowireapsettings2{'wpa_passphrase'} = 'smoothiemods';			### hostapd
#$nowireapsettings2{'wpa_psk'} = '0123456789abcdef0123456789abcdef0123456789abcdef0123456789abcdef';	### hostapd
#$nowireapsettings2{'wpa_psk_file'} = '/etc/hostapd.wpa_psk';		# hostapd
$nowireapsettings2{'wpa_key_mgmt'} = 'WPA-PSK';				# hostapd
#$nowireapsettings2{'wpa_pairwise'} = 'TKIP CCMP';			# hostapd
$nowireapsettings2{'wpa_pairwise'} = 'TKIP';				### hostapd
################################
&getcgihash(\%nowireapsettings);


my $errormessage = '';

if ($nowireapsettings{'ACTION'} eq Save)
{
	if ($nowireapsettings{'NOWIREAP_WEP_KEY_TO_USE'} eq '1') {
		$nowireapsettings{'NOWIREAP_IWCONFIG_WEP_KEY'} = $nowireapsettings{'NOWIREAP_WEP_KEY1'};
	} elsif ($nowireapsettings{'NOWIREAP_WEP_KEY_TO_USE'} eq '2') {
		$nowireapsettings{'NOWIREAP_IWCONFIG_WEP_KEY'} = $nowireapsettings{'NOWIREAP_WEP_KEY2'};
	} elsif ($nowireapsettings{'NOWIREAP_WEP_KEY_TO_USE'} eq '3') {
		$nowireapsettings{'NOWIREAP_IWCONFIG_WEP_KEY'} = $nowireapsettings{'NOWIREAP_WEP_KEY3'};
	} elsif ($nowireapsettings{'NOWIREAP_WEP_KEY_TO_USE'} eq '4') {
		$nowireapsettings{'NOWIREAP_IWCONFIG_WEP_KEY'} = $nowireapsettings{'NOWIREAP_WEP_KEY4'};
	}

	&writehash("${swroot}/preferences/nowireap", \%nowireapsettings);
	system ("/bin/sort ${swroot}/preferences/nowireap -o ${swroot}/preferences/nowireap");
#	system ("/var/smoothwall/mods/nowireap/modfiles/nowireaphelper");	### change settings on-the-fly


	$nowireapsettings2{'ssid'} = $nowireapsettings{'NOWIREAP_IWCONFIG_ESSID'};
	$nowireapsettings2{'channel'} = $nowireapsettings{'NOWIREAP_IWCONFIG_CHANNEL'};
	$nowireapsettings2{'rts_threshold'} = $nowireapsettings{'NOWIREAP_IWCONFIG_RTS'};
	$nowireapsettings2{'fragm_threshold'} = $nowireapsettings{'NOWIREAP_IWCONFIG_FRAG'};
	$nowireapsettings2{'ignore_broadcast_ssid'} = $nowireapsettings{'NOWIREAP_IWPRIV_HIDE_SSID'};
	$nowireapsettings2{'beacon_int'} = $nowireapsettings{'NOWIREAP_IWPRIV_BINTVAL'};
	if ($nowireapsettings{'NOWIREAP_SECURITY_MODE'} eq 'wpa') {
		$nowireapsettings2{'wpa'} = '1';
	} elsif ($nowireapsettings{'NOWIREAP_SECURITY_MODE'} eq 'none') {
		$nowireapsettings2{'wpa'} = '0';
	} else {
		$nowireapsettings2{'wpa'} = '0';
	}
	$nowireapsettings2{'wpa_passphrase'} = $nowireapsettings{'NOWIREAP_WPA_KEY'};
	$nowireapsettings2{'wpa_pairwise'} = $nowireapsettings{'NOWIREAP_WPA_ALGORITHM'};
	
	&writehash("${swroot}/preferences/nowireap2", \%nowireapsettings2);
	system ("/bin/sort ${swroot}/preferences/nowireap2 -o ${swroot}/preferences/nowireap2");
	system ("${swroot}/mods/nowireap/modfiles/nowireaphelper2-02test4");

}

system ("/bin/touch ${swroot}/preferences/nowireap");
&readhash("${swroot}/preferences/nowireap", \%nowireapsettings);


system ("/bin/touch ${swroot}/preferences/nowireap2");
&readhash("${swroot}/preferences/nowireap2", \%nowireapsettings2);	###hostap settings


$checked{'NOWIREAP_ACTIVATE_AP'}{'off'} = '';
$checked{'NOWIREAP_ACTIVATE_AP'}{'on'} = '';
$checked{'NOWIREAP_ACTIVATE_AP'}{$nowireapsettings{'NOWIREAP_ACTIVATE_AP'}} = 'CHECKED';



$checked{'NOWIREAP_IWPRIV_HIDE_SSID'}{'off'} = '';
$checked{'NOWIREAP_IWPRIV_HIDE_SSID'}{'on'} = '';
$checked{'NOWIREAP_IWPRIV_HIDE_SSID'}{$nowireapsettings{'NOWIREAP_IWCONFIG_HIDE_SSID'}} = 'CHECKED';



$selected{'NOWIREAP_IWCONFIG_TXPOWER'}{'off'} = '';
for ($i=1; $i <= 18; $i++){
	$selected{'NOWIREAP_IWCONFIG_TXPOWER'}{'$i'} = '';
}
$selected{'NOWIREAP_IWCONFIG_TXPOWER'}{'auto'} = '';
$selected{'NOWIREAP_IWCONFIG_TXPOWER'}{$nowireapsettings{'NOWIREAP_IWCONFIG_TXPOWER'}} = 'SELECTED';



for ($i=1; $i <= 11; $i++){
	$selected{'NOWIREAP_IWCONFIG_CHANNEL'}{'$i'} = '';
}
$selected{'NOWIREAP_IWCONFIG_CHANNEL'}{$nowireapsettings{'NOWIREAP_IWCONFIG_CHANNEL'}} = 'SELECTED';



$selected{'NOWIREAP_IWCONFIG_RATE'}{'auto'} = '';
for ($i=1; $i <= 54; $i++){
	$selected{'NOWIREAP_IWCONFIG_CHANNEL'}{'$i'} = '';
}
$selected{'NOWIREAP_IWCONFIG_RATE'}{$nowireapsettings{'NOWIREAP_IWCONFIG_RATE'}} = 'SELECTED';



$selected{'NOWIREAP_IWPRIV_MODE'}{'0'} = '';
$selected{'NOWIREAP_IWPRIV_MODE'}{'1'} = '';
$selected{'NOWIREAP_IWPRIV_MODE'}{'2'} = '';
$selected{'NOWIREAP_IWPRIV_MODE'}{'3'} = '';
$selected{'NOWIREAP_IWPRIV_MODE'}{'4'} = '';
$selected{'NOWIREAP_IWPRIV_MODE'}{'5'} = '';
$selected{'NOWIREAP_IWPRIV_MODE'}{'6'} = '';
$selected{'NOWIREAP_IWPRIV_MODE'}{'7'} = '';
$selected{'NOWIREAP_IWPRIV_MODE'}{$nowireapsettings{'NOWIREAP_IWPRIV_MODE'}} = 'SELECTED';



$checked{'NOWIREAP_IWPRIV_TURBO'}{'off'} = '';
$checked{'NOWIREAP_IWPRIV_TURBO'}{'on'} = '';
$checked{'NOWIREAP_IWPRIV_TURBO'}{$nowireapsettings{'NOWIREAP_IWPRIV_TURBO'}} = 'CHECKED';



$selected{'NOWIREAP_SECURITY_MODE'}{'none'} = '';
$selected{'NOWIREAP_SECURITY_MODE'}{'wep'} = '';
$selected{'NOWIREAP_SECURITY_MODE'}{'wpa'} = '';
$selected{'NOWIREAP_SECURITY_MODE'}{$nowireapsettings{'NOWIREAP_SECURITY_MODE'}} = 'SELECTED';



$selected{'NOWIREAP_WEP_KEY_TO_USE'}{'1'} = '';
$selected{'NOWIREAP_WEP_KEY_TO_USE'}{'2'} = '';
$selected{'NOWIREAP_WEP_KEY_TO_USE'}{'3'} = '';
$selected{'NOWIREAP_WEP_KEY_TO_USE'}{'4'} = '';
$selected{'NOWIREAP_WEP_KEY_TO_USE'}{$nowireapsettings{'NOWIREAP_WEP_KEY_TO_USE'}} = 'SELECTED';




$selected{'NOWIREAP_WPA_ALGORITHM'}{'tkip'} = '';
$selected{'NOWIREAP_WPA_ALGORITHM'}{'aes'} = '';
$selected{'NOWIREAP_WPA_ALGORITHM'}{$nowireapsettings{'NOWIREAP_WPA_ALGORITHM'}} = 'SELECTED';



&nowireapREFRESHset();



#&openpage('nowireap', 1, '', 'networking');

&shownetworkingsection();

&openbigbox('100%', 'LEFT');

if ($nowireapsettings{'NOWIREAP_HIDE_ALERTBOX'} eq 'on') {
	###then do nothing
} else {
	&alertbox($errormessage);
}



print "<FORM METHOD='POST'>\n";
#&openbox('100%', 'LEFT');
&openbox('100%', 'LEFT', 'Wireless Settings: ');

&nowireapDISPLAYmenu();

print "</FORM>\n";
&closebox();

##########
###MAIN###
##########

&nowireapDISPLAYmain();

&closebigbox();
&closepage();

$t1 = gettimeofday(); $t2=$t1-$t0;
print "<PRE><center>Page generated in ", sprintf ('%.2f', $t2), " seconds.</center></PRE>";

##########
###DONE###
##########





#################
###SUBROUTINES###
#################


sub nowireapREFRESHset {
	my $refresh = $nowireapsettings{'NOWIREAP_REFRESH'};
	if ($refresh > 0)
	{
		print "Refresh: $refresh\n";
		print "Cache-Control: no-cache\n";
		print "Pragma: no-cache\n";
	}
	&showhttpheaders();
	$t0 = gettimeofday();
#	&openpage('nowireap', 1, '', 'networking');
	&openpage('Simple wireless access point configuration', 1, '', 'networking');
}



sub nowireapDISPLAYmenu {

print qq|
<table width='100%' border='0' cellspacing='0' cellpadding='0'>
<TR>
|;



print qq|
<TD align='right' width='50%'>
Enable Access Point: &nbsp;&nbsp;
</TD>
<TD>
<INPUT TYPE='checkbox' NAME='NOWIREAP_ACTIVATE_AP' $checked{'NOWIREAP_ACTIVATE_AP'}{'on'}> (Enable/Disable requires REBOOT)
</TD>
</TR>
|;



### reference - http://madwifi.org/users-guide/node4.html
###	iwconfig ath0 essid "Atheros Wireless Network" 
print qq|
<TR>
<TD align='right' width='50%'>
ESSID or Network Name: &nbsp;&nbsp;
</TD>
<TD width='50%'>
<INPUT TYPE='text' NAME='NOWIREAP_IWCONFIG_ESSID' SIZE=16 MAXLENGTH=15 VALUE='$nowireapsettings{'NOWIREAP_IWCONFIG_ESSID'}'>
</TD>
</TR>
|;



### reference - http://madwifi.org/users-guide/node20.html
###	iwpriv ath0 hide_ssid 1
print qq|
<TR>
<TD align='right' width='50%'>
Hide SSID: &nbsp;&nbsp;
</TD>
<TD>
<INPUT TYPE='checkbox' OPTION VALUE='1' NAME='NOWIREAP_IWPRIV_HIDE_SSID' $checked{'NOWIREAP_IWPRIV_HIDE_SSID'}{'1'}>
</TD>
</TR>
|;



### reference - http://madwifi.org/users-guide/node5.html
###	iwconfig ath0 channel 11
print "<TR>";
print "<TD align='right' width='50%'>";
print "Channel - RF Frequency: &nbsp;&nbsp;";
print "</TD><TD>";
print "<SELECT NAME='NOWIREAP_IWCONFIG_CHANNEL'>";
print "<OPTION VALUE='1' $selected{'NOWIREAP_IWCONFIG_CHANNEL'}{'1'}> 1 - 2.412 GHz";
print "<OPTION VALUE='2' $selected{'NOWIREAP_IWCONFIG_CHANNEL'}{'2'}> 2 - 2.417 GHz";
print "<OPTION VALUE='3' $selected{'NOWIREAP_IWCONFIG_CHANNEL'}{'3'}> 3 - 2.422 GHz";
print "<OPTION VALUE='4' $selected{'NOWIREAP_IWCONFIG_CHANNEL'}{'4'}> 4 - 2.427 GHz";
print "<OPTION VALUE='5' $selected{'NOWIREAP_IWCONFIG_CHANNEL'}{'5'}> 5 - 2.432 GHz";
print "<OPTION VALUE='6' $selected{'NOWIREAP_IWCONFIG_CHANNEL'}{'6'}> 6 - 2.437 GHz";
print "<OPTION VALUE='7' $selected{'NOWIREAP_IWCONFIG_CHANNEL'}{'7'}> 7 - 2.442 GHz";
print "<OPTION VALUE='8' $selected{'NOWIREAP_IWCONFIG_CHANNEL'}{'8'}> 8 - 2.447 GHz";
print "<OPTION VALUE='9' $selected{'NOWIREAP_IWCONFIG_CHANNEL'}{'9'}> 9 - 2.452 GHz";
print "<OPTION VALUE='10' $selected{'NOWIREAP_IWCONFIG_CHANNEL'}{'10'}>10 - 2.457 GHz";
print "<OPTION VALUE='11' $selected{'NOWIREAP_IWCONFIG_CHANNEL'}{'11'}>11 - 2.462 GHz";
#print "<OPTION VALUE='12' $selected{'NOWIREAP_IWCONFIG_CHANNEL'}{'12'}>12 - ";	### europe
#print "<OPTION VALUE='13' $selected{'NOWIREAP_IWCONFIG_CHANNEL'}{'13'}>13 - ";	### europe
print "</SELECT></TD>";
print "</TR>";



### Data Transmit Rate - http://madwifi.org/users-guide/node8.html
###                      http://madwifi.org/ticket/867
###	iwconfig ath0 rate 36M auto
print "<TR>";
print "<TD align='right' width='50%'>";
print "Data Transmit Rate: &nbsp;&nbsp;"; 
print "</TD><TD>";
print "<SELECT NAME='NOWIREAP_IWCONFIG_RATE'>";
print "       <OPTION VALUE='auto' $selected{'NOWIREAP_IWCONFIG_RATE'}{'auto'}>auto";
#for ($i=1000000; $i <= 54000000; $i+1000000){
#print qq|
#	<OPTION VALUE='$i' $selected{'NOWIREAP_IWCONFIG_RATE'}{$i}>$i-1000000 M
#|;
#}
print qq|
	<OPTION VALUE='1000000' $selected{'NOWIREAP_IWCONFIG_RATE'}{'1000000'}>1 M
	<OPTION VALUE='2000000' $selected{'NOWIREAP_IWCONFIG_RATE'}{'2000000'}>2 M
	<OPTION VALUE='5000000' $selected{'NOWIREAP_IWCONFIG_RATE'}{'5000000'}>5 M
	<OPTION VALUE='11000000' $selected{'NOWIREAP_IWCONFIG_RATE'}{'11000000'}>11 M
	<OPTION VALUE='24000000' $selected{'NOWIREAP_IWCONFIG_RATE'}{'24000000'}>24 M
	<OPTION VALUE='36000000' $selected{'NOWIREAP_IWCONFIG_RATE'}{'36000000'}>36 M
	<OPTION VALUE='48000000' $selected{'NOWIREAP_IWCONFIG_RATE'}{'48000000'}>48 M
	<OPTION VALUE='54000000' $selected{'NOWIREAP_IWCONFIG_RATE'}{'54000000'}>54 M
|;
print "</SELECT>";
print "</TD>";
print "</TR>";


### reference - http://madwifi.org/users-guide/node18.html
###	iwpriv ath0 mode auto
###	iwpriv ath0 mode 1
#print "<TR>";
#print "<TD align='right' width='50%'>";
#print "Mode: &nbsp;&nbsp;"; 
#print "</TD><TD>";
#print "<SELECT NAME='NOWIREAP_IWPRIV_MODE'>";
#print "<OPTION VALUE='0' $selected{'NOWIREAP_IWPRIV_MODE'}{'0'}>Auto select operating mode";
##print "<OPTION VALUE='1' $selected{'NOWIREAP_IWPRIV_MODE'}{'1'}>802.11a (5GHz) mode (54Mbps)";
##print "<OPTION VALUE='2' $selected{'NOWIREAP_IWPRIV_MODE'}{'2'}>802.11b (2.4GHz) mode (11Mbps)";
##print "<OPTION VALUE='3' $selected{'NOWIREAP_IWPRIV_MODE'}{'3'}>802.11g (2.4GHz) mode with 802.11b compatibility (54Mbps)";
##print "<OPTION VALUE='4' $selected{'NOWIREAP_IWPRIV_MODE'}{'4'}>802.11 frequency hopping mode";
##print "<OPTION VALUE='5' $selected{'NOWIREAP_IWPRIV_MODE'}{'5'}>802.11a (5GHz) dynamic turbo mode";
##print "<OPTION VALUE='6' $selected{'NOWIREAP_IWPRIV_MODE'}{'6'}>802.11g (2GHz) dynamic turbo mode (108Mbps)";
##print "<OPTION VALUE='7' $selected{'NOWIREAP_IWPRIV_MODE'}{'7'}>802.11a (5GHz) static turbo mode";
#print "</SELECT>";
#print "</TD>";
#print "</TR>";



### reference - http://madwifi.org/wiki/UserDocs/TurboMode
###	iwpriv ath0 turbo 1
#print qq|
#<TR>
#<TD align='right' width='50%'>
#Enable Turbo: &nbsp;&nbsp;
#<INPUT TYPE='checkbox' OPTION VALUE='1' NAME='NOWIREAP_IWPRIV_TURBO' $checked{'NOWIREAP_IWPRIV_TURBO'}{'1'}>
#</TD>
#</TR>
#|;







### reference - http://madwifi.org/users-guide/node12.html
###	iwconfig ath0 txpower 30
print "<TR>";
print "<TD align='right' width='50%'>";
print "Transmit Power: &nbsp;&nbsp;";
print "</TD><TD>";
print "<SELECT NAME='NOWIREAP_IWCONFIG_TXPOWER'>";
print "<OPTION VALUE='off' $selected{'NOWIREAP_IWCONFIG_TXPOWER'}{'0'}>off";
for ($i=1; $i <= 18; $i++){
	print "<OPTION VALUE='$i' $selected{'NOWIREAP_IWCONFIG_TXPOWER'}{$i}>$i";
}
print "<OPTION VALUE='auto' $selected{'NOWIREAP_IWCONFIG_TXPOWER'}{'auto'}>auto";
print "</SELECT></TD>";
print "</TR>";


### Set Beacon Interval Value - http://madwifi.org/users-guide/node32.html
###	iwpriv ath0 bintval 25
print qq|
<TR>
<TD align='right' width='50%'>
Beacon Interval: &nbsp;&nbsp;
</TD>
<TD>
<INPUT TYPE='text' NAME='NOWIREAP_IWPRIV_BINTVAL' SIZE=16 MAXLENGTH=15 VALUE='$nowireapsettings{'NOWIREAP_IWPRIV_BINTVAL'}'>
</TD>
</TR>
|;



### reference - http://madwifi.org/users-guide/node10.html
###	iwconfig ath0 frag 512
print qq|
<TR>
<TD align='right' width='50%'>
Fragmentation Threshold: &nbsp;&nbsp;
</TD>
<TD>
<INPUT TYPE='text' NAME='NOWIREAP_IWCONFIG_FRAG' SIZE=16 MAXLENGTH=15 VALUE='$nowireapsettings{'NOWIREAP_IWCONFIG_FRAG'}'>
</TD>
</TR>
|;



### reference - http://madwifi.org/users-guide/node9.html
###	iwconfig ath0 rts 40
print qq|
<TR>
<TD align='right' width='50%'>
RTS/CTS Threshold: &nbsp;&nbsp;
</TD>
<TD>
<INPUT TYPE='text' NAME='NOWIREAP_IWCONFIG_RTS' SIZE=16 MAXLENGTH=15 VALUE='$nowireapsettings{'NOWIREAP_IWCONFIG_RTS'}'>
</TD>

|;



print "</tr></table>";
&closebox;




### WEP Encryption Keys and Mode - http://madwifi.org/users-guide/node11.html
###	iwconfig ath0 key [3]  
###	iwconfig ath0 key xxxx-xxxx-xx
###	iwconfig ath0 key [2] s:password open 
###	iwconfig ath0 key off 


&openbox('100%', 'LEFT', 'Security Settings: ');

print qq|
<table width='100%' border='0' cellspacing='0' cellpadding='0'>
<TR>
|;




print "<TD CLASS='base'>";
print "&nbsp;";
print "Security Mode: ";
print "<SELECT NAME='NOWIREAP_SECURITY_MODE'>";
print "       <OPTION VALUE='none' $selected{'NOWIREAP_SECURITY_MODE'}{'none'}>None";
print "       <OPTION VALUE='wep' $selected{'NOWIREAP_SECURITY_MODE'}{'wep'}>WEP";
print "       <OPTION VALUE='wpa' $selected{'NOWIREAP_SECURITY_MODE'}{'wpa'}>WPA";
print "</SELECT>";
print "</td>";
print "</tr>";




&nowireapDISPLAYnone();
&nowireapDISPLAYwep();
&nowireapDISPLAYwpa();


print "</tr></table>";
&closebox;






















&openbox('100%', 'LEFT', '');

print qq|
<DIV ALIGN='CENTER'>
<table width='100%' border='0' cellspacing='0' cellpadding='0'>
<TR>
	<TD ALIGN='CENTER'><INPUT TYPE='submit' NAME='ACTION' VALUE='$tr{'save'}'></TD> 
</TR>
</TABLE>
</DIV>
|;
#&closebox();



}








sub nowireapDISPLAYmain {

if ($nowireapsettings{'NOWIREAP_SHOW_PREFERENCES'} eq 'on') {
	&openbox('100%', 'LEFT', 'Preferences: ');
	print "<PRE>";
	system ('cat', '/var/smoothwall/preferences/nowireap');
	print "</PRE>\n";
	&closebox();
}

if ($nowireapsettings{'NOWIREAP_SHOW_HOSTAPD_PREFERENCES'} eq 'on') {
	&openbox('100%', 'LEFT', 'Preferences: ');
	print "<PRE>";
	system ('cat', '/var/smoothwall/preferences/nowireap2');
	print "</PRE>\n";
	&closebox();
}


if ($nowireapsettings{'NOWIREAP_SHOW_HOSTAPD_CONF'} eq 'on') {
	&openbox('100%', 'LEFT', 'hostapd.conf: ');
	print "<PRE>";
	system ('cat', '/etc/hostapd/hostapd.conf');
	print "</PRE>\n";
	&closebox();
}



if ($nowireapsettings{'NOWIREAP_SHOW_IFCONFIG'} eq 'on') {
	&openbox('100%', 'LEFT', 'ifconfig output: ');
	print "<PRE>";
	system ('/sbin/ifconfig');
#	system ('/sbin/ifconfig', '-a');
#	system ('/sbin/ifconfig', 'ath0');
#	system ('/sbin/ifconfig', 'wifi0');
	print "</PRE>\n";
	&closebox();
}

if ($nowireapsettings{'NOWIREAP_SHOW_IWCONFIG'} eq 'on') {
	&openbox('100%', 'LEFT', 'iwconfig output: ');
	print "<PRE>";
#	system ('/usr/local/sbin/iwconfig');
	system ('/usr/local/sbin/iwconfig', 'ath0');
	print "</PRE>\n";
	&closebox();
}

if ($nowireapsettings{'NOWIREAP_SHOW_IWPRIV'} eq 'on') {
	&openbox('100%', 'LEFT', 'iwpriv output: ');
	print "<PRE>";
#	system ('/usr/local/sbin/iwpriv');
	system ('/usr/local/sbin/iwpriv', 'ath0');
	print "</PRE>\n";
	&closebox();
}



}













sub nowireapDISPLAYnone {
if ($nowireapsettings{'NOWIREAP_SECURITY_MODE'} eq 'none') {
print "<tr><td>";
#print "nothing here";

&goSAVEwepSETTINGS();

print "</td></tr>";

}

}







sub nowireapDISPLAYwep {


if ($nowireapsettings{'NOWIREAP_SECURITY_MODE'} eq 'wep') {
print "<tr><td>";
print "&nbsp;&nbsp;&nbsp;&nbsp;";
print "Use Encryption Key: ";
print "<SELECT NAME='NOWIREAP_WEP_KEY_TO_USE'>";
for ($i=1; $i <= 4; $i++){
	print "<OPTION VALUE='$i' $selected{'NOWIREAP_WEP_KEY_TO_USE'}{$i}>$i";
}
print "</SELECT>";
print "</td></tr>";



### reference - http://madwifi.org/users-guide/node8.html
### 	iwconfig ath0 key xxxx-xxxx-xx
### 	iwconfig ath0 key off
### reference - http://madwifi.org/wiki/UserDocs/SimpleWEPClient
print qq|
<tr><td>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
Key 1: <INPUT TYPE='text' NAME='NOWIREAP_WEP_KEY1' SIZE=40 MAXLENGTH=26 VALUE='$nowireapsettings{'NOWIREAP_WEP_KEY1'}'>
</td></tr>
<tr><td>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
Key 2: <INPUT TYPE='text' NAME='NOWIREAP_WEP_KEY2' SIZE=40 MAXLENGTH=26 VALUE='$nowireapsettings{'NOWIREAP_WEP_KEY2'}'>
</td></tr>
<tr><td>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
Key 3: <INPUT TYPE='text' NAME='NOWIREAP_WEP_KEY3' SIZE=40 MAXLENGTH=26 VALUE='$nowireapsettings{'NOWIREAP_WEP_KEY3'}'>
</td></tr>
<tr><td>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
Key 4: <INPUT TYPE='text' NAME='NOWIREAP_WEP_KEY4' SIZE=40 MAXLENGTH=26 VALUE='$nowireapsettings{'NOWIREAP_WEP_KEY4'}'>
</TD>
|;


&goSAVEwpaSETTINGS();
}
}





sub nowireapDISPLAYwpa {
if ($nowireapsettings{'NOWIREAP_SECURITY_MODE'} eq 'wpa') {
print "<tr><td>";



print "&nbsp;&nbsp;&nbsp;&nbsp;";
print "WPA Algorithm: ";
print "<SELECT NAME='NOWIREAP_WPA_ALGORITHM'>";
#print "<OPTION VALUE='tkip' $selected{'NOWIREAP_WPA_ALGORITHM'}{'tkip'}>TKIP (Temporal Key Intergrity Protocol)";
print "<OPTION VALUE='TKIP' $selected{'NOWIREAP_WPA_ALGORITHM'}{'tkip'}>TKIP (Temporal Key Intergrity Protocol)";
#print "<OPTION VALUE='aes' $selected{'NOWIREAP_WPA_ALGORITHM'}{'aes'}>AES (Advanced Encryption System)";
print "</SELECT>";
print "</td></tr>";

print "<tr><td>";
print "&nbsp;&nbsp;&nbsp;&nbsp;";
print "WPA Pre-Shared Key: <INPUT TYPE='text' NAME='NOWIREAP_WPA_KEY' SIZE=40 MAXLENGTH=63 VALUE='$nowireapsettings{'NOWIREAP_WPA_KEY'}'>";
print "</td></tr>";




&goSAVEwepSETTINGS();

print "</td></tr>";

}

}









sub goSAVEwepSETTINGS {

print qq|
<INPUT TYPE='hidden' NAME='NOWIREAP_WEP_KEY_TO_USE' VALUE='$nowireapsettings{'NOWIREAP_WEP_KEY_TO_USE'}'>
<INPUT TYPE='hidden' NAME='NOWIREAP_WEP_KEY1' VALUE='$nowireapsettings{'NOWIREAP_WEP_KEY1'}'>
<INPUT TYPE='hidden' NAME='NOWIREAP_WEP_KEY2' VALUE='$nowireapsettings{'NOWIREAP_WEP_KEY2'}'>
<INPUT TYPE='hidden' NAME='NOWIREAP_WEP_KEY3' VALUE='$nowireapsettings{'NOWIREAP_WEP_KEY3'}'>
<INPUT TYPE='hidden' NAME='NOWIREAP_WEP_KEY4' VALUE='$nowireapsettings{'NOWIREAP_WEP_KEY4'}'>
|;

}



sub goSAVEwpaSETTINGS {

print qq|
<INPUT TYPE='hidden' NAME='NOWIREAP_WPA_ALGORITHM' VALUE='$nowireapsettings{'NOWIREAP_WPA_ALGORITHM'}'>
<INPUT TYPE='hidden' NAME='NOWIREAP_WPA_KEY' VALUE='$nowireapsettings{'NOWIREAP_WPA_KEY'}'>
|;

}



sub GOmacFILTER {


}